#!/bin/sh
####
#
# SuSE monthly security check v2.0 by Marc Heuse <marc@suse.de>
#
# Geaendert und ins Deutsche uebersetzt von Lars Rupp <l.rupp@web.de>
#
####

. /etc/rc.config

export PATH="/sbin:/usr/sbin:/bin:/usr/bin"
umask 077
test -z "$SEC_BIN" && SEC_BIN="/usr/lib/secchk"
test -z "$SEC_VAR" && SEC_VAR="/var/lib/secchk"
SEC_DATA="$SEC_VAR/data"
OLD1="$SEC_VAR/security-report-daily"
OLD2="$SEC_VAR/security-report-weekly"
OLD3="$SEC_VAR/security-report-monthly"
if [ ! -d "$SEC_VAR" ]; then
    rm -rf "$SEC_VAR"
    mkdir "$SEC_VAR" || exit 1
fi
if [ ! -d "$SEC_DATA" ]; then
    rm -rf "$SEC_DATA"
    mkdir "$SEC_DATA" || exit 1
fi
for i in "$OLD1" "$OLD2" "$OLD3" ; do
    if [ "$i" != "" ]; then
        if [ ! -e "$i" ]; then
    	    touch "$i"
        fi
    fi
done
for i in "$SEC_DATA/rpm-md5" "$SEC_DATA/sbit" "$SEC_DATA/write" "$SEC_DATA/devices" ; do
    if [ ! -e "$i" ] ; then
        touch "$i"
    fi
done

echo -e '\nBEMERKUNG: haben Sie schon bei http://www.suse.de/security nach Security-Updates nachgesehen?!\n'

cat "$OLD1"

if [ -x /usr/sbin/john -a -x /usr/sbin/unshadow ]; then
    echo -e '\nKomplette Liste von Nutzer-Accounts mit zu einfachen Passwoertern:'
    unshadow /etc/passwd /etc/shadow > $SEC_VAR/passwd
    john -show "$SEC_VAR/passwd" | sed -n 's/:.*//p'
    /bin/rm -f $SEC_VAR/passwd
fi

echo -e '\nKomplette Liste von Nutzer-Accounts welche ein Passwort haben - die aber nicht benutzt werden:'
$SEC_BIN/checkneverlogin

echo -e '\nKomplette Liste von schreibbaren und ausfuehrbaren Programmen:'
cat "$SEC_DATA/write-bin"

echo -e '\nKomplette Liste von Dateien mit suid/sgid:'
cat "$SEC_DATA/sbit"

echo -e '\nKomplette Liste von weltweit schreibbaren Dateien:'
cat "$SEC_DATA/write"

echo -e '\nKomplette Liste aller geaenderten installierten Pakete:'
cat "$SEC_DATA/rpm-md5"

echo -e '\nKomplette Liste von (zeichen- /blockorientierten) Geraeten:'
cat "$SEC_DATA/devices"

#echo -e '\nComplete list of x:\n'
#cat "$SEC_DATA/perms"

exit 0
